#include<iostream>
#include<math.h>
using namespace std;
int NZD(int a, int b) 
{
   if (b==0)
   return a;
   return NZD(b, a%b);
}
int NZDN(int a[],int n)
{
    for(int i=1;i<n;i++)
        a[i]=NZD(a[i],a[i-1]);
    return a[n-1];
}
int main()
{
    int T;
    cin>>T;
    for(int i=0;i<T;i++)
    {
        int n,m;
        cin>>n>>m;
        int a[n];
        int b[m];
        for(int j=0;j<n;j++)
            cin>>a[i];
        for(int j=0;j<m;j++)
            cin>>b[i];
        int razA[n-1];
        for(int j=0;j<n-1;j++)
            razA[j]=abs(razA[j]-razA[j+1]);
        int razB[m-1];
        for(int j=0;j<m-1;j++)
            razB[j]=abs(razB[j]-razB[j+1]);
        int a=NZDN(razA,n);
        int b=NZDN(razb,m);
        if(a>b)
            cout<<1;
        else if(a<=b && b%a==0 && abs(a[0]-b[0])%a==0)
            cout<<0;
        else if(a<b && b%a==0)
            cout<<1;
        else cout<<1;
        cout<<endl;
    }
}